const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const employee_schedule_assignments = sequelize.define(
    'employee_schedule_assignments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

start_date: {
        type: DataTypes.DATE,
      
      

      },

end_date: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"ended"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  employee_schedule_assignments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.employee_schedule_assignments.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });

    db.employee_schedule_assignments.belongsTo(db.work_schedules, {
      as: 'work_schedule',
      foreignKey: {
        name: 'work_scheduleId',
      },
      constraints: false,
    });

    db.employee_schedule_assignments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.employee_schedule_assignments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.employee_schedule_assignments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return employee_schedule_assignments;
};


